getObjectById=\
    SELECT * FROM page WHERE id=?

getObjectListByIds=\
    SELECT * FROM page WHERE id IN (??)

getObjectByParentPathAccountAndAccount=\
    SELECT * FROM page WHERE heimid=? AND parentpathaccount=? AND account=?

getPageList.first.all=\
    SELECT ?? FROM ?? ??

getPageList.first.length=\
    SELECT ?? FROM ?? ?? LIMIT :length

getPageList.offset.all=\
    SELECT ?? FROM ?? ?? OFFSET :offset

getPageList.offset.length=\
    SELECT ?? FROM ?? ?? LIMIT :length OFFSET :offset

# 'permission.roleid=8' means "all" role,
# 'casto.groupid=5' means "all" group,
# 'permission.roleid=9' means "owner" role
PageConditionParser.privilegeCondition=\
    page.id=permission.pageid AND permission.type=:permission_type \
    AND permission.level>=:permission_level \
    AND permission.roleid=casto.roleid \
    AND casto.groupid=member.groupid \
    AND (permission.roleid=8 \
    OR casto.groupid=5 \
    OR permission.roleid=9 AND page.owneruserid=:user_id \
    OR casto.userid=:user_id OR member.userid=:user_id)

childAccountExists=\
    SELECT COUNT(*) FROM page WHERE heimid=? AND parentpathaccount=? AND account=?

insert.getMaxOrderNumber=\
    SELECT COALESCE(MAX(ordernumber), 0) FROM page WHERE heimid=? AND parentpathAccount=?

insert.getId=\
    SELECT CURRVAL('page_id_seq')

updateById.where=\
    id=?

deleteById=\
    DELETE FROM page WHERE id=?

changeLordId=\
    UPDATE page SET lordid=? \
        WHERE heimid=? AND parentpathaccount=? AND account=? OR lordid=? AND \
            (parentpathaccount=? OR parentpathaccount LIKE ? ESCAPE '|')

moveTo.updateTarget=\
    UPDATE page SET parentpathaccount=?,account=? WHERE heimid=? AND parentpathaccount=? AND account=?

moveTo.updateDescendants=\
    UPDATE page SET parentpathaccount=? || COALESCE(SUBSTRING(parentpathaccount FROM ?),'') WHERE heimid=? AND (parentpathaccount=? OR parentpathaccount LIKE ? ESCAPE '|')

#
# FOR INITIALIZATION
#
initialize=createPageSequence,createPage, \
    createPageIndex1,createPageIndex2,createPageIndex3,createPageIndex4, \
    insertRootPage, \
    insertAdministratorUser,insertAnonymousUser, \
    insertAdministratorGroup,insertAllGroup, \
    insertAdministratorRole,insertAnonymousRole, \
    insertAllRole,insertOwnerRole, \
    insertAlfheimRootPage, \
    insertUsersPage,insertGroupsPage,insertRolesPage, \
    insertTemplatesPage,insertSystemPage,insertPluginsPage, \
    insertDummyPage,setPageSequence,deleteDummyPage
initialize.specific.pre=
initialize.specific.post=
initialize.createPageSequence= \
    CREATE SEQUENCE page_id_seq
initialize.createPage= \
    CREATE TABLE page ( \
        id                  INTEGER DEFAULT NEXTVAL('page_id_seq') NOT NULL PRIMARY KEY, \
        type                VARCHAR(255) NOT NULL, \
        heimid              INTEGER NOT NULL, \
        lordid              INTEGER NOT NULL, \
        parentpathaccount   VARCHAR(255) NOT NULL, \
        account             VARCHAR(255) NOT NULL, \
        ordernumber         INTEGER NOT NULL, \
        createdate          TIMESTAMP NOT NULL, \
        modifydate          TIMESTAMP NOT NULL, \
        owneruserid         INTEGER NOT NULL, \
        concealed           BOOLEAN NOT NULL, \
        node                BOOLEAN NOT NULL, \
        UNIQUE              (heimid, parentpathaccount, account) \
    )
initialize.createPageIndex1= \
    CREATE INDEX page_type_idx ON page (type)
initialize.createPageIndex2= \
    CREATE INDEX page_lordid_idx ON page (lordid)
initialize.createPageIndex3= \
    CREATE INDEX page_account_idx ON page (account)
initialize.createPageIndex4= \
    CREATE INDEX page_parentpathaccount_idx ON page (heimid, parentpathaccount)
initialize.insertRootPage= \
    INSERT INTO page VALUES (\
        1, 'directory', 0, \
        1, '_', '', \
        1, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 1 \
    )
initialize.insertAdministratorUser= \
    INSERT INTO page VALUES (\
        2, 'user', 0, \
        1, '/users', 'administrator', \
        1, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 0 \
    )
initialize.insertAnonymousUser= \
    INSERT INTO page VALUES (\
        3, 'user', 0, \
        1, '/users', 'anonymous', \
        2, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 0 \
    )
initialize.insertAdministratorGroup= \
    INSERT INTO page VALUES (\
        4, 'group', 0, \
        1, '/groups', 'administrator', \
        1, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 0 \
    )
initialize.insertAllGroup= \
    INSERT INTO page VALUES (\
        5, 'group', 0, \
        1, '/groups', 'all', \
        2, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 0 \
    )
initialize.insertAdministratorRole= \
    INSERT INTO page VALUES (\
        6, 'role', 0, \
        1, '/roles', 'administrator', \
        1, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 0 \
    )
initialize.insertAnonymousRole= \
    INSERT INTO page VALUES (\
        7, 'role', 0, \
        1, '/roles', 'anonymous', \
        2, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 0 \
    )
initialize.insertAllRole= \
    INSERT INTO page VALUES (\
        8, 'role', 0, \
        1, '/roles', 'all', \
        3, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 0 \
    )
initialize.insertOwnerRole= \
    INSERT INTO page VALUES (\
        9, 'role', 0, \
        1, '/roles', 'owner', \
        4, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 0 \
    )
initialize.insertAlfheimRootPage= \
    INSERT INTO page VALUES (\
        10, 'directory', 1, \
        10, '_', '', \
        2, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 1 \
    )
initialize.insertUsersPage= \
    INSERT INTO page VALUES (\
        101, 'directory', 0, \
        1, '', 'users', \
        1, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 1 \
    )
initialize.insertGroupsPage= \
    INSERT INTO page VALUES (\
        102, 'directory', 0, \
        1, '', 'groups', \
        2, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 1 \
    )
initialize.insertRolesPage= \
    INSERT INTO page VALUES (\
        103, 'directory', 0, \
        1, '', 'roles', \
        3, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 1 \
    )
initialize.insertTemplatesPage= \
    INSERT INTO page VALUES (\
        104, 'directory', 0, \
        1, '', 'templates', \
        4, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 1 \
    )
initialize.insertSystemPage= \
    INSERT INTO page VALUES (\
        105, 'directory', 0, \
        1, '', 'system', \
        5, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 1 \
    )
initialize.insertPluginsPage= \
    INSERT INTO page VALUES (\
        106, 'directory', 0, \
        1, '', 'plugins', \
        6, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 2, 0, 1 \
    )
initialize.insertDummyPage= \
    INSERT INTO page VALUES (\
        1000, '', 1, \
        1, '_', 'dummy', \
        0, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, 0, 0, 0 \
    )
initialize.setPageSequence= \
    SELECT SETVAL('page_id_seq', 1000)
initialize.deleteDummyPage= \
    DELETE FROM page WHERE id=1000
